Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 364489 - net-libs/webkit-gtk-1.2.7 broken on Perl 5.14 due to using Switch.pm
Summary: net-libs/webkit-gtk-1.2.7 broken on Perl 5.14 due to using Switch.pm
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: [OLD] Library (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Gentoo Perl team
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: perl-5.14.0
  Show dependency tree
 
Reported: 2011-04-22 15:36 UTC by Kent Fredric (IRC: kent\n) (RETIRED)
Modified: 2012-01-22 16:25 UTC (History)
6 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
webkit-1.4.1-givenwhen.patch (webkit-1.4.1-givenwhen.patch,1.10 KB, patch)
2011-06-19 18:16 UTC, Torsten Veller (RETIRED)
Details | Diff
webkit-1.2.7-givenwhen.patch (webkit-1.2.7-givenwhen.patch,844 bytes, patch)
2011-06-19 18:17 UTC, Torsten Veller (RETIRED)
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Kent Fredric (IRC: kent\n) (RETIRED) gentoo-dev 2011-04-22 15:36:42 UTC
Switch.pm has been deprecated a while, and is no longer shipped with Perl. 

This is used in webkit-gtk's  WebCore/dom/make_names.pl , and the absense of Switch.pm thusly makes Webkit-gtk not compilable.

mv CSSPropertyNames.* ./DerivedSources
  GEN    DerivedSources/HTMLElementFactory.cpp
  GEN    DerivedSources/HTMLEntityNames.c
  GEN    DerivedSources/HTMLNames.cpp
Can't locate Switch.pm in @INC (@INC contains: ./WebCore/bindings/scripts /etc/perl /usr/local/lib64/perl5/5.14/x86_64-linux-thread-multi /usr/local/lib64/perl5/5.14 /usr/lib64/perl5/vendor_perl/5.14/x86_64-linux-thread-multi /usr/lib64/perl5/vendor_perl/5.14 /usr/lib64/perl5/5.14/x86_64-linux-thread-multi /usr/lib64/perl5/5.14 .) at WebCore/dom/make_names.pl line 38.
BEGIN failed--compilation aborted at WebCore/dom/make_names.pl line 38.
make: *** [DerivedSources/HTMLElementFactory.cpp] Error 2
make: *** Waiting for unfinished jobs....
Can't locate Switch.pm in @INC (@INC contains: ./WebCore/bindings/scripts /etc/perl /usr/local/lib64/perl5/5.14/x86_64-linux-thread-multi /usr/local/lib64/perl5/5.14 /usr/lib64/perl5/vendor_perl/5.14/x86_64-linux-thread-multi /usr/lib64/perl5/vendor_perl/5.14 /usr/lib64/perl5/5.14/x86_64-linux-thread-multi /usr/lib64/perl5/5.14 .) at WebCore/dom/make_names.pl line 38.
BEGIN failed--compilation aborted at WebCore/dom/make_names.pl line 38.
make: *** [DerivedSources/HTMLNames.cpp] Error 2
mv CSSValueKeywords.* ./DerivedSources
/usr/libexec/paludis/utils/emake: emake returned error 2
Comment 1 Gilles Dartiguelongue gentoo-dev 2011-04-24 13:41:34 UTC
emerge --info and full build.log please.
Comment 2 Torsten Veller (RETIRED) gentoo-dev 2011-04-24 18:21:35 UTC
Removed perl core modules are also new to us and we'll have to check what we do best. This is probably a perl bug right now. Feel free to remove the gnome team.

With warnings turned on, you'll see the deprecation hint added in perl-5.12 (see below). Switch will be removed in perl-5.14 (which will be released soon). Currently we are tracking all failure.

We'll have to check if
- webkit upstream is going to use the given/when feature (released in perl-5.10) or
- we patch it :( or
- we add Switch to dev-lang/perl-5.14 or
- we add and depend on dev-perl/Switch (bug #351065).

http://search.cpan.org/~jesse/perl-5.14.0-RC1/pod/perl5120delta.pod#Deprecated_Modules


$ perl5.12.2 -cw ./webkit-1.3.13/Source/WebCore/make-hash-tools.pl
Switch will be removed from the Perl core distribution in the next major release. Please install it from CPAN. It is being used at ./webkit-1.3.13/Source/WebCore/make-hash-tools.pl, line 23.
./webkit-1.3.13/Source/WebCore/make-hash-tools.pl syntax OK

$ PERL5LIB=./webkit-1.2.7/WebCore/bindings/scripts perl5.12.2 -cw ./webkit-1.2.7/WebCore/dom/make_names.pl
Switch will be removed from the Perl core distribution in the next major release. Please install it from CPAN. It is being used at ./webkit-1.2.7/WebCore/dom/make_names.pl, line 38.
./webkit-1.2.7/WebCore/dom/make_names.pl syntax OK
Comment 3 Torsten Veller (RETIRED) gentoo-dev 2011-06-19 16:39:16 UTC
By now we have found two packages using Switch.pm:
net-libs/webkit-gtk itself and the bundled webkit in www-client/chromium.


I've added perl-core/Switch and virtual/perl-Switch to the tree and the two packages should depend on virtual/perl-Switch.

If nobody finds a better solution, I'll file a new KEYWORDREQ bug for the new packages in two days.
Comment 4 Pacho Ramos gentoo-dev 2011-06-19 17:11:52 UTC
Have you rechecked with webkit-gtk-1.4* ?
Comment 5 Alexandre Rostovtsev (RETIRED) gentoo-dev 2011-06-19 18:16:02 UTC
webkit-gtk-1.4.1 has the same issue, it uses Switch.pm in Source/WebCore/make-hash-tools.pl
Comment 6 Torsten Veller (RETIRED) gentoo-dev 2011-06-19 18:16:36 UTC
Created attachment 277545 [details, diff]
webkit-1.4.1-givenwhen.patch

Replace Switch by given-when for webkit-1.4.1
Comment 7 Torsten Veller (RETIRED) gentoo-dev 2011-06-19 18:17:18 UTC
Created attachment 277547 [details, diff]
webkit-1.2.7-givenwhen.patch

...and for webkit-1.2.7
Comment 8 Paweł Hajdan, Jr. (RETIRED) gentoo-dev 2011-06-19 19:38:38 UTC
Have you reported the issues upstream and submitted patches upstream? It should be fairly easy to get that fixed upstream, and I'd be glad to help with the procedures.
Comment 9 Priit Laes (IRC: plaes) 2011-06-20 07:19:30 UTC
Upstream issue: https://bugs.webkit.org/show_bug.cgi?id=61890
Comment 10 Paweł Hajdan, Jr. (RETIRED) gentoo-dev 2011-06-21 07:22:21 UTC
The upstream patch has landed. Link to unified diff: <http://trac.webkit.org/changeset/89265/trunk/Source/WebCore/make-hash-tools.pl?format=diff&new=89265>
Comment 11 Aaron W. Swenson gentoo-dev 2012-01-22 16:01:15 UTC
Can this be marked FIXED now? It was fixed upstream and merged into 1.4.2. The lowest version available in our tree is 1.4.3.

http://trac.webkit.org/log/releases/WebKitGTK/webkit-1.4.2?action=follow_copy&mode=follow_copy&rev=90183&stop_rev=90147&limit=100
Comment 12 Pacho Ramos gentoo-dev 2012-01-22 16:25:28 UTC
Thanks for the heads up